diff -r fb51f5b4aa4c trytond/model/fields/many2many.py
--- a/trytond/model/fields/many2many.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/fields/many2many.py	Mon Sep 24 20:36:36 2012 +0200
@@ -60,12 +60,6 @@
     def get(self, ids, model, name, values=None):
         '''
         Return target records ordered.
-
-        :param ids: a list of ids
-        :param model: a string with the name of the model
-        :param name: a string with the name of the field
-        :param values: a dictionary with the read values
-        :return: a dictionary with ids as key and values as value
         '''
         if values is None:
             values = {}
@@ -80,41 +74,34 @@
         else:
             order = self.order
 
-        relation_obj = Pool().get(self.relation_name)
-        if self.origin in relation_obj._columns:
-            origin_field = relation_obj._columns[self.origin]
+        Relation = Pool().get(self.relation_name)
+        if self.origin in Relation._fields:
+            origin_field = Relation._fields[self.origin]
         else:
-            origin_field = relation_obj._inherit_fields[self.origin][2]
+            origin_field = Relation._inherit_fields[self.origin][2]
 
-        relation_ids = []
+        relations = []
         for i in range(0, len(ids), Transaction().cursor.IN_MAX):
             sub_ids = ids[i:i + Transaction().cursor.IN_MAX]
             if origin_field._type == 'reference':
-                references = ['%s,%s' % (model._name, x) for x in sub_ids]
+                references = ['%s,%s' % (model.__name__, x) for x in sub_ids]
                 clause = [(self.origin, 'in', references)]
             else:
                 clause = [(self.origin, 'in', sub_ids)]
             clause += [(self.target + '.id', '!=', None)]
-            relation_ids.append(relation_obj.search(clause, order=order))
-        relation_ids = list(chain(*relation_ids))
+            relations.append(Relation.search(clause, order=order))
+        relations = list(chain(*relations))
 
-        for relation in relation_obj.browse(relation_ids):
-            if origin_field._type == 'reference':
-                _, origin_id = relation[self.origin].split(',')
-                origin_id = int(origin_id)
-            else:
-                origin_id = relation[self.origin].id
-            res[origin_id].append(relation[self.target].id)
-        return res
+        for relation in relations:
+            origin_id = getattr(relation, self.origin).id
+            res[origin_id].append(getattr(relation, self.target).id)
+        return dict((key, tuple(value)) for key, value in res.iteritems())
 
     def set(self, ids, model, name, values):
         '''
         Set the values.
 
-        :param ids: A list of ids
-        :param model: A string with the name of the model
-        :param name: A string with the name of the field
-        :param values: A list of tuples:
+        values: A list of tuples:
             (``create``, ``{<field name>: value}``),
             (``write``, ``<ids>``, ``{<field name>: value}``),
             (``delete``, ``<ids>``),
@@ -127,44 +114,44 @@
         pool = Pool()
         if not values:
             return
-        relation_obj = pool.get(self.relation_name)
-        target_obj = self.get_target()
+        Relation = pool.get(self.relation_name)
+        Target = self.get_target()
 
-        if self.origin in relation_obj._columns:
-            origin_field = relation_obj._columns[self.origin]
+        if self.origin in Relation._fields:
+            origin_field = Relation._fields[self.origin]
         else:
-            origin_field = relation_obj._inherit_fields[self.origin][2]
+            origin_field = Relation._inherit_fields[self.origin][2]
 
         def search_clause(ids):
             if origin_field._type == 'reference':
-                references = ['%s,%s' % (model._name, x) for x in ids]
+                references = ['%s,%s' % (model.__name__, x) for x in ids]
                 return (self.origin, 'in', references)
             else:
                 return (self.origin, 'in', ids)
 
         def field_value(record_id):
             if origin_field._type == 'reference':
-                return '%s,%s' % (model._name, record_id)
+                return '%s,%s' % (model.__name__, record_id)
             else:
                 return record_id
 
         for act in values:
             if act[0] == 'create':
                 for record_id in ids:
-                    relation_obj.create({
+                    Relation.create({
                             self.origin: field_value(record_id),
-                            self.target: target_obj.create(act[1]),
+                            self.target: Target.create(act[1]).id,
                             })
             elif act[0] == 'write':
-                target_obj.write(act[1], act[2])
+                Target.write(Target.browse(act[1]), act[2])
             elif act[0] == 'delete':
-                target_obj.delete(act[1])
+                Target.delete(Target.browse(act[1]))
             elif act[0] == 'delete_all':
-                relations = relation_obj.browse(relation_obj.search([
-                            search_clause(ids),
-                            ]))
-                target_obj.delete([r[self.target].id for r in relations
-                        if r[self.target].id])
+                relations = Relation.search([
+                        search_clause(ids),
+                        ])
+                Target.delete([getattr(r, self.target) for r in relations
+                        if getattr(r, self.target)])
             elif act[0] == 'unlink':
                 if isinstance(act[1], (int, long)):
                     target_ids = [act[1]]
@@ -172,58 +159,55 @@
                     target_ids = list(act[1])
                 if not target_ids:
                     continue
-                relation_ids = []
+                relations = []
                 for i in range(0, len(target_ids),
                         Transaction().cursor.IN_MAX):
                     sub_ids = target_ids[i:i + Transaction().cursor.IN_MAX]
-                    relation_ids += relation_obj.search([
+                    relations += Relation.search([
                             search_clause(ids),
                             (self.target, 'in', sub_ids),
                             ])
-                relation_obj.delete(relation_ids)
+                Relation.delete(relations)
             elif act[0] == 'add':
-                if isinstance(act[1], (int, long)):
-                    target_ids = [act[1]]
-                else:
-                    target_ids = list(act[1])
+                target_ids = list(act[1])
                 if not target_ids:
                     continue
                 existing_ids = []
                 for i in range(0, len(target_ids),
                         Transaction().cursor.IN_MAX):
                     sub_ids = target_ids[i:i + Transaction().cursor.IN_MAX]
-                    relation_ids = relation_obj.search([
+                    relations = Relation.search([
                             search_clause(ids),
                             (self.target, 'in', sub_ids),
                             ])
-                    for relation in relation_obj.browse(relation_ids):
-                        existing_ids.append(relation[self.target].id)
+                    for relation in relations:
+                        existing_ids.append(getattr(relation, self.target).id)
                 for new_id in (x for x in target_ids if x not in existing_ids):
                     for record_id in ids:
-                        relation_obj.create({
+                        Relation.create({
                                 self.origin: field_value(record_id),
                                 self.target: new_id,
                                 })
             elif act[0] == 'unlink_all':
-                target_ids = relation_obj.search([
+                targets = Relation.search([
                         search_clause(ids),
                         (self.target + '.id', '!=', None),
                         ])
-                relation_obj.delete(target_ids)
+                Relation.delete(targets)
             elif act[0] == 'set':
                 if not act[1]:
                     target_ids = []
                 else:
                     target_ids = list(act[1])
-                target_ids2 = relation_obj.search([
+                targets2 = Relation.search([
                         search_clause(ids),
                         (self.target + '.id', '!=', None),
                         ])
-                relation_obj.delete(target_ids2)
+                Relation.delete(targets2)
 
                 for new_id in target_ids:
                     for record_id in ids:
-                        relation_obj.create({
+                        Relation.create({
                                 self.origin: field_value(record_id),
                                 self.target: new_id,
                                 })
@@ -231,18 +215,24 @@
                 raise Exception('Bad arguments')
 
     def get_target(self):
-        '''
-        Return the target model.
+        'Return the target model'
+        Relation = Pool().get(self.relation_name)
+        if not self.target:
+            return Relation
+        if self.target in Relation._fields:
+            return Relation._fields[self.target].get_target()
+        else:
+            return Relation._inherit_fields[self.target][2].get_target()
 
-        :return: A Model
-        '''
-        relation_obj = Pool().get(self.relation_name)
-        if not self.target:
-            return relation_obj
-        if self.target in relation_obj._columns:
-            target_obj = Pool().get(
-                    relation_obj._columns[self.target].model_name)
-        else:
-            target_obj = Pool().get(
-                    relation_obj._inherit_fields[self.target][2].model_name)
-        return target_obj
+    def __set__(self, inst, value):
+        Target = self.get_target()
+
+        def instance(data):
+            if isinstance(data, Target):
+                return data
+            elif isinstance(data, dict):
+                return Target(**data)
+            else:
+                return Target(data)
+        value = [instance(x) for x in (value or [])]
+        super(Many2Many, self).__set__(inst, value)
diff -r fb51f5b4aa4c trytond/model/fields/many2one.py
--- a/trytond/model/fields/many2one.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/fields/many2one.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1,7 +1,9 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
+from types import NoneType
 
 from trytond.model.fields.field import Field
+from trytond.pool import Pool
 
 
 class Many2One(Field):
@@ -45,6 +47,7 @@
         self.left = left
         self.right = right
         self.datetime_field = datetime_field
+    __init__.__doc__ += Field.__init__.__doc__
 
     def __get_required(self):
         return self.__required
@@ -56,4 +59,15 @@
 
     required = property(__get_required, __set_required)
 
-    __init__.__doc__ += Field.__init__.__doc__
+    def get_target(self):
+        'Return the target Model'
+        return Pool().get(self.model_name)
+
+    def __set__(self, inst, value):
+        Target = self.get_target()
+        if isinstance(value, dict):
+            value = Target(**value)
+        elif isinstance(value, (int, long)):
+            value = Target(value)
+        assert isinstance(value, (Target, NoneType))
+        super(Many2One, self).__set__(inst, value)
diff -r fb51f5b4aa4c trytond/model/fields/one2many.py
--- a/trytond/model/fields/one2many.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/fields/one2many.py	Mon Sep 24 20:36:36 2012 +0200
@@ -76,19 +76,13 @@
     def get(self, ids, model, name, values=None):
         '''
         Return target records ordered.
-
-        :param ids: a list of ids
-        :param model: the model
-        :param name: a string with the name of the field
-        :param values: a dictionary with the read values
-        :return: a dictionary with ids as key and values as value
         '''
         pool = Pool()
-        relation_obj = pool.get(self.model_name)
-        if self.field in relation_obj._columns:
-            field = relation_obj._columns[self.field]
+        Relation = pool.get(self.model_name)
+        if self.field in Relation._fields:
+            field = Relation._fields[self.field]
         else:
-            field = relation_obj._inherit_fields[self.field][2]
+            field = Relation._inherit_fields[self.field][2]
         res = {}
         for i in ids:
             res[i] = []
@@ -96,11 +90,11 @@
         for i in range(0, len(ids), Transaction().cursor.IN_MAX):
             sub_ids = ids[i:i + Transaction().cursor.IN_MAX]
             if field._type == 'reference':
-                references = ['%s,%s' % (model._name, x) for x in sub_ids]
+                references = ['%s,%s' % (model.__name__, x) for x in sub_ids]
                 clause = [(self.field, 'in', references)]
             else:
                 clause = [(self.field, 'in', sub_ids)]
-            ids2.append(relation_obj.search(clause, order=self.order))
+            ids2.append(map(int, Relation.search(clause, order=self.order)))
 
         cache = Transaction().cursor.get_cache(Transaction().context)
         cache.setdefault(self.model_name, {})
@@ -118,7 +112,7 @@
                 ids3.append(i)
 
         if ids3:
-            for i in relation_obj.read(ids3, [self.field]):
+            for i in Relation.read(ids3, [self.field]):
                 if field._type == 'reference':
                     _, id_ = i[self.field].split(',')
                     id_ = int(id_)
@@ -128,18 +122,14 @@
 
         index_of_ids2 = dict((i, index)
             for index, i in enumerate(chain(*ids2)))
-        for val in res.values():
-            val.sort(key=lambda x: index_of_ids2[x])
+        for id_, val in res.iteritems():
+            res[id_] = tuple(sorted(val, key=lambda x: index_of_ids2[x]))
         return res
 
     def set(self, ids, model, name, values):
         '''
         Set the values.
-
-        :param ids: A list of ids
-        :param model: the model
-        :param name: A string with the name of the field
-        :param values: A list of tuples:
+        values: A list of tuples:
             (``create``, ``{<field name>: value}``),
             (``write``, ``<ids>``, ``{<field name>: value}``),
             (``delete``, ``<ids>``),
@@ -149,25 +139,24 @@
             (``unlink_all``),
             (``set``, ``<ids>``)
         '''
-        pool = Pool()
         if not values:
             return
-        target_obj = pool.get(self.model_name)
-        if self.field in target_obj._columns:
-            field = target_obj._columns[self.field]
+        Target = self.get_target()
+        if self.field in Target._fields:
+            field = Target._fields[self.field]
         else:
-            field = target_obj._inherit_fields[self.field][2]
+            field = Target._inherit_fields[self.field][2]
 
         def search_clause(ids):
             if field._type == 'reference':
-                references = ['%s,%s' % (model._name, x) for x in ids]
+                references = ['%s,%s' % (model.__name__, x) for x in ids]
                 return (self.field, 'in', references)
             else:
                 return (self.field, 'in', ids)
 
         def field_value(record_id):
             if field._type == 'reference':
-                return '%s,%s' % (model._name, record_id)
+                return '%s,%s' % (model.__name__, record_id)
             else:
                 return record_id
 
@@ -175,63 +164,75 @@
             if act[0] == 'create':
                 for record_id in ids:
                     act[1][self.field] = field_value(record_id)
-                    target_obj.create(act[1])
+                    Target.create(act[1])
             elif act[0] == 'write':
-                target_obj.write(act[1], act[2])
+                Target.write(Target.browse(act[1]), act[2])
             elif act[0] == 'delete':
-                target_obj.delete(act[1])
+                Target.delete(Target.browse(act[1]))
             elif act[0] == 'delete_all':
-                target_obj.delete(target_obj.search([
-                            search_clause(ids),
-                            ]))
+                targets = Target.search([
+                        search_clause(ids),
+                        ])
+                Target.delete(targets)
             elif act[0] == 'unlink':
-                if isinstance(act[1], (int, long)):
-                    target_ids = [act[1]]
-                else:
-                    target_ids = list(act[1])
+                target_ids = map(int, act[1])
                 if not target_ids:
                     continue
-                target_ids = target_obj.search([
+                targets = Target.search([
                         search_clause(ids),
                         ('id', 'in', target_ids),
                         ])
-                target_obj.write(target_ids, {
+                Target.write(targets, {
                         self.field: None,
                         })
             elif act[0] == 'add':
-                if isinstance(act[1], (int, long)):
-                    target_ids = [act[1]]
-                else:
-                    target_ids = list(act[1])
+                target_ids = map(int, act[1])
                 if not target_ids:
                     continue
                 for record_id in ids:
-                    target_obj.write(target_ids, {
+                    Target.write(Target.browse(target_ids), {
                             self.field: field_value(record_id),
                             })
             elif act[0] == 'unlink_all':
-                target_ids = target_obj.search([
+                targets = Target.search([
                         search_clause(ids),
                         ])
-                target_obj.write(target_ids, {
+                Target.write(targets, {
                         self.field: None,
                         })
             elif act[0] == 'set':
                 if not act[1]:
-                    target_ids = [0]
+                    target_ids = [-1]
                 else:
-                    target_ids = list(act[1])
+                    target_ids = map(int, act[1])
                 for record_id in ids:
-                    target_ids2 = target_obj.search([
+                    targets = Target.search([
                             search_clause([record_id]),
                             ('id', 'not in', target_ids),
                             ])
-                    target_obj.write(target_ids2, {
+                    Target.write(targets, {
                             self.field: None,
                             })
                     if act[1]:
-                        target_obj.write(target_ids, {
+                        Target.write(Target.browse(target_ids), {
                                 self.field: field_value(record_id),
                                 })
             else:
                 raise Exception('Bad arguments')
+
+    def get_target(self):
+        'Return the target Model'
+        return Pool().get(self.model_name)
+
+    def __set__(self, inst, value):
+        Target = self.get_target()
+
+        def instance(data):
+            if isinstance(data, Target):
+                return data
+            elif isinstance(data, dict):
+                return Target(**data)
+            else:
+                return Target(data)
+        value = [instance(x) for x in (value or [])]
+        super(One2Many, self).__set__(inst, value)
diff -r fb51f5b4aa4c trytond/model/fields/one2one.py
--- a/trytond/model/fields/one2one.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/fields/one2one.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1,6 +1,8 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
+from types import NoneType
 
+from trytond.model.fields.field import Field
 from trytond.model.fields.many2many import Many2Many
 from trytond.pool import Pool
 
@@ -36,14 +38,23 @@
         :param value: The id to link
         '''
         pool = Pool()
-        relation_obj = pool.get(self.relation_name)
-        relation_ids = relation_obj.search([
-            (self.origin, 'in', ids),
-            ])
-        relation_obj.delete(relation_ids)
+        Relation = pool.get(self.relation_name)
+        relations = Relation.search([
+                (self.origin, 'in', ids),
+                ])
+        Relation.delete(relations)
         if value:
             for record_id in ids:
-                relation_obj.create({
-                    self.origin: record_id,
-                    self.target: value,
-                    })
+                Relation.create({
+                        self.origin: record_id,
+                        self.target: value,
+                        })
+
+    def __set__(self, inst, value):
+        Target = self.get_target()
+        if isinstance(value, dict):
+            value = Target(*value)
+        elif isinstance(value, (int, long)):
+            value = Target(value)
+        assert isinstance(value, (Target, NoneType))
+        Field.__set__(self, inst, value)
diff -r fb51f5b4aa4c trytond/model/fields/property.py
--- a/trytond/model/fields/property.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/fields/property.py	Mon Sep 24 20:36:36 2012 +0200
@@ -25,6 +25,9 @@
     def __copy__(self):
         return Property(copy.copy(self._field))
 
+    def __deepcopy__(self, memo):
+        return Property(copy.deepcopy(self._field))
+
     def get(self, ids, model, name, values=None):
         '''
         Retreive the property.
@@ -36,9 +39,8 @@
         :return: a dictionary with ids as key and values as value
         '''
         pool = Pool()
-        property_obj = pool.get('ir.property')
-        res = property_obj.get(name, model._name, ids)
-        return res
+        Property = pool.get('ir.property')
+        return Property.get(name, model.__name__, ids)
 
     def set(self, ids, model, name, value):
         '''
@@ -50,13 +52,13 @@
         :param value: The value to set.
         '''
         pool = Pool()
-        property_obj = pool.get('ir.property')
+        Property = pool.get('ir.property')
         if value is not None:
             prop_value = '%s,%s' % (getattr(self, 'model_name', ''),
                 str(value))
         else:
             prop_value = None
-        return property_obj.set(name, model._name, ids, prop_value)
+        Property.set(name, model.__name__, ids, prop_value)
 
     def search(self, model, name, clause):
         '''
@@ -65,21 +67,21 @@
         :return: New list of domain.
         '''
         pool = Pool()
-        rule_obj = pool.get('ir.rule')
-        property_obj = pool.get('ir.property')
-        model_obj = pool.get('ir.model')
-        field_obj = pool.get('ir.model.field')
+        Rule = pool.get('ir.rule')
+        Property = pool.get('ir.property')
+        Model = pool.get('ir.model')
+        Field = pool.get('ir.model.field')
         cursor = Transaction().cursor
 
         field_class = backend.FIELDS[self._type]
         if not field_class:
             return []
-        sql_type = field_class.sql_type(model._columns[name])
+        sql_type = field_class.sql_type(model._fields[name])
         if not sql_type:
             return []
         sql_type = sql_type[0]
 
-        property_query, property_val = rule_obj.domain_get('ir.property')
+        property_query, property_val = Rule.domain_get('ir.property')
 
         property_clause = ''
         if property_query:
@@ -88,27 +90,27 @@
         #Fetch res ids that comply with the domain
         cursor.execute(
             'SELECT CAST('
-                'SPLIT_PART("' + property_obj._table + '".res,\',\',2) '
+                'SPLIT_PART("' + Property._table + '".res,\',\',2) '
                     'AS INTEGER), '
-                '"' + property_obj._table + '".id '
-            'FROM "' + property_obj._table + '" '
-                'JOIN "' + field_obj._table + '" ON '
-                    '("' + field_obj._table + '"' +
-                        '.id = "' + property_obj._table + '".field) '
-                'JOIN "' + model_obj._table + '" ON '
-                    '("' + model_obj._table +
-                        '".id = "' + field_obj._table + '".model) '
+                '"' + Property._table + '".id '
+            'FROM "' + Property._table + '" '
+                'JOIN "' + Field._table + '" ON '
+                    '("' + Field._table + '"' +
+                        '.id = "' + Property._table + '".field) '
+                'JOIN "' + Model._table + '" ON '
+                    '("' + Model._table +
+                        '".id = "' + Field._table + '".model) '
             'WHERE '
                 'CASE WHEN "' +
-                    model_obj._table + '".model = %s '
-                    'AND "' + field_obj._table + '".name = %s '
+                    Model._table + '".model = %s '
+                    'AND "' + Field._table + '".name = %s '
                     + property_clause +
                 ' THEN ' +
                     self.get_condition(sql_type, clause) +
                 ' ELSE '
                     '%s '
                 'END',
-            [model._name, name] + property_val +
+            [model.__name__, name] + property_val +
             self.get_condition_args(clause) + [False])
 
         props = cursor.fetchall()
@@ -134,7 +136,7 @@
         #Fetch the res ids that doesn't use the default value
         cursor.execute(
             "SELECT cast(split_part(res,',',2) as integer) "
-            'FROM "' + property_obj._table + '"'
+            'FROM "' + Property._table + '"'
             'WHERE ' + property_query + ' AND res is not null',
             property_val)
 
diff -r fb51f5b4aa4c trytond/model/fields/reference.py
--- a/trytond/model/fields/reference.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/fields/reference.py	Mon Sep 24 20:36:36 2012 +0200
@@ -1,6 +1,8 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 import contextlib
+from types import NoneType
+
 from trytond.model.fields.field import Field
 from trytond.transaction import Transaction
 from trytond.pool import Pool
@@ -32,13 +34,7 @@
 
     def get(self, ids, model, name, values=None):
         '''
-        Replace removed reference id by False.
-
-        :param ids: a list of ids
-        :param model: a string with the name of the model
-        :param name: a string with the name of the field
-        :param values: a dictionary with the read values
-        :return: a dictionary with ids as key and values as value
+        Replace removed reference id by None.
         '''
         pool = Pool()
         if values is None:
@@ -71,15 +67,28 @@
         with contextlib.nested(Transaction().set_context(active_test=False),
                 Transaction().set_user(0)):
             for ref_model, (ref_ids, ids) in ref_to_check.iteritems():
-                if ref_model not in pool.object_name_list():
-                    res.update(dict((i, False) for i in ids))
+                try:
+                    pool.get(ref_model)
+                except KeyError:
+                    res.update(dict((i, None) for i in ids))
                     continue
-                ref_obj = pool.get(ref_model)
-                ref_ids = ref_obj.search([
+                Ref = pool.get(ref_model)
+                refs = Ref.search([
                     ('id', 'in', list(ref_ids)),
                     ], order=[])
-                refs = [ref_model + ',' + str(ref_id) for ref_id in ref_ids]
+                refs = map(str, refs)
                 for i in ids:
                     if res[i] not in refs:
-                        res[i] = False
+                        res[i] = None
         return res
+
+    def __set__(self, inst, value):
+        from ..model import Model
+        if not isinstance(value, (Model, NoneType)):
+            if isinstance(value, basestring):
+                target, id_ = value.split(',')
+            else:
+                target, id_ = value
+            Target = Pool().get(target)
+            value = Target(id_)
+        super(Reference, self).__set__(inst, value)
